browser.webRequest.onHeadersReceived.addListener(logSubject,
  {urls: ["https://*/*","http://*/*"],types: ["main_frame"]},
  ["blocking"]
);
browser.runtime.onMessage.addListener(handleMessage);
browser.tabs.onUpdated.addListener(handleUpdated);
browser.tabs.onActivated.addListener(handleActivated);


var gettingInfo = undefined;


//funció per administrar els errors
function onError(error) {
  console.error(`Error: ${error}`);
}

//Obtenim el tab actiu de la finesta activa
function getActiveTab() {
  return browser.tabs.query({active: true, currentWindow: true});
}

//Obtenim la informació sobre el TLS i la guardem a la variable 'gettingInfo' per després passar-la al script main.js que imprimirà i farà els càlculs al pop-up
async function logSubject(details) {
	try {
			gettingInfo = await browser.webRequest.getSecurityInfo(details.requestId,{"certificateChain": true,"rawDER": true });

	}
	catch(onError) {
	}
}

//Funció que s'executa en rebre un missatge, s'usa com a trigger per enviar la informació TLS
function handleMessage(message, sender) {
  if (message === "init") {
    browser.runtime.sendMessage(gettingInfo);
  } else {
    console.log("No s'ha pogut enviar missatge amb la informació de seguretat");
  }
}

//Avisem que s'ha de recargar la pàgina per tal d'obtenir les dades necessàries de seguretat, sino em mostraran les anteriors que es van obtenir
function handleActivated(activeInfo) {

   console.log("Reload the current URL to get the security info into the extension! @rankSSL. By Oriol Secall ;) ");
   browser.browserAction.setIcon({path: "../icons/TLSicon38.png"});
}

//Per canviar icona a la neutral al canviar de URL
function handleUpdated(tabId, changeInfo, tabInfo) {
  if (changeInfo.url) {
   
   console.log("Reload the current URL to get the security info into the extension! @rankSSL. By Oriol Secall ;) ");
   browser.browserAction.setIcon({path: "../icons/TLSicon38.png"});
  }
}