import * as asn1js from 'asn1js';
import { Certificate } from 'pkijs';
import { fromBase64, stringToArrayBuffer} from 'pvutils';
import * as moment from 'moment';
import { strings, AlgoritmeSignature } from './strings.js';
import * as IDBFiles from 'idb-file-storage'

//Enviam missatge al script en segon pla perquè enviï la informació (trigger)
browser.runtime.sendMessage("init");
/* -------------- Puntuació ----------------- */
//Puntuació TOTAL
var puntuacioTOTAL =0.0;
//Puntuació total dels certificats ponderats
var puntuacio_cadena_certificats =0.0;
// Puntuacio certificats CA
var puntuacio_CAs = 0.0;
// Puntuacio certificat Web
var puntuacio_web = 0.0;
//Puntuació connexió
var puntuacio_connexio = 0.0;
//Puntuació Algoritma Signatura i mida de la clau
var puntuacioSignature =0.0;
//Puntuació CertStatus
var puntuacioCERTstatus = 0.0; //0 o 10
//Puntuació mida claus RSA i ECC public key
var puntuacioClauPublica = 0.0;
//Puntuació EV (Extended Validation)
var puntuacioEV = 0.0; //0 o 10
//Puntuació PFS (Forward Secrecy)
var pfs=0.0; //0 o 10.0
//AEAD (Authenticated Encryption with Additional Data)
var AEAD = false;

/* --- Puntuació per a Cipher Sute ---- */
var puntuacioCPS = 0.0; //Puntuació total CPS (TLS, KeyExchange, Bulk Cipher, MACHash)
var puntuacioProto_TLS = 0.0; //Puntuació protocol SSL/TLS
var puntuacioKE = 0.0; //Puntuacio Key Exchange Algorithm (intercanvi claus)
var puntuacioAUTH = 0.0;
var puntuacioBC = 0.0; //Puntuacio Bulk Cipher (simetric) 
var puntuacioHash = 0.0; //Puntuació MAC Hash 40% 
var puntuacioCPS_Total = 0.0; //Puntuació del cipher suite
/* --------------------------------------*/
//Miscellanious ------------------------------------------
//Variable per imprimir la ruta de certificació
const id_p_CN =["CN_1","CN_2","CN_3"];
//Variable per mostrar el màxim de la puntuació possible
const maxim = "10";
//Variable per bucles
var i=0;
var j=0;
var h=0;
//Variable per crear les estrelles del rating
var estrelles = 0;
//Guardarem informació sobre la TAB actual
var tab ="";
//Flag per anular puntuació total
var anulacio_puntacio=false;
//String constant per informar que una extensió és crítica
const criticExtension = "(Critical extension):";
//Per modificar paragrafs
var node_tmp = undefined;
var p_tmp = undefined;
//Propietats CPS
var hash = undefined;
var BC = undefined;
var KE = undefined;
var sign="";
//URL visitada sense el 'path'
var URL_short = undefined;
//Variable per emmagatzemar JSON
var json_string = {
	
	'https': undefined,
	'score': undefined,
	'url': undefined,
	
	'critics':{
		'domainMatches':undefined,
		'trustable':undefined
	},	
	'scores': {

		'connection': {
			'weight' : undefined,
			'score': undefined,
			'cipherSuite': {
				'score': undefined, 
				'weight': undefined, 
				'value': undefined,
				'protocol': {name: undefined, score: undefined, weight: undefined},
				'keyExchange': {name: undefined, score: undefined, weight: undefined},
				'signature': {name: undefined, score: undefined, weight: undefined},
				'bulkCipher': {name: undefined, score: undefined, weight: undefined, AEAD:false},
				'MAChash': {name: undefined, score: undefined, weight: undefined}
			},			
			'extendedValidation': {score: undefined, weight: undefined},
			'perfectForwardSecrecy': {score: undefined, weight: undefined},
			'certificateTransparency': {name: undefined}
		},

		'chainCertificates':{
			'weight' : undefined,
			'score': undefined,
			'certificates': {
				
				'certificateWeb':{
					'score': undefined,
					'weight': undefined,
					'publicKey':{name: undefined, score: undefined, weight: undefined},
					'signature':{name: undefined, score: undefined, weight: undefined},
					'valid':{value: undefined, score: undefined, weight: undefined},
					'basicConstraints' : undefined
				},
				'certificateCA':{
					'score': undefined,
					'weight': undefined,
					'publicKey':{name: undefined, score: undefined, weight: undefined},
					'signature':{name: undefined, score: undefined, weight: undefined},
					'valid':{value: undefined, score: undefined, weight: undefined},
					'basicConstraints': undefined
				},
				'certificateCAroot':{
					'score': undefined,
					'weight': undefined,
					'publicKey':{name: undefined, score: undefined, weight: undefined},
					'signature':{name: undefined, score: undefined, weight: undefined},
					'valid':{value: undefined, score: undefined, weight: undefined},
					'basicConstraints': undefined
				}
			}
		
		}
			
			
	}
};

/* ------------------------------------------- */
 
/* -------------- Pesos ---------------- */ 

//Pesos
var pes_connexio = 0.60;
var pes_cadena_certificats = 0.40;
//Pes connexió 
var pes_PFS = 0.15;	
var pes_EV = 0.15;	
var pes_CPS = 0.70;
//Pes certificats en la cadena
var pes_certWEB = 0.50;
var pes_certCA = 0.25; 
var pes_certROOT = 0.25; 
//Components certificat
var pes_SIG = 0.50;
var pes_PK = 0.30;
var pes_certStatus = 0.20;
//Cipher suite components
var pes_TLS = 0.10;
var pes_KE = 0.30;
var pes_SIGAUTH= 0.10;
var pes_BC = 0.20;
var pes_Hash = 0.30;

/* --------------------------------------- */
//Obtenim els pesos de la configuració de l'extensió
get_weights_score();
//Afegim listener per obtenir el missatge del script en segon pla (background) i així obtenir la informació de la seguretat de la connexió
browser.runtime.onMessage.addListener((message) => {
//Analitzem la connexió a partir de la informació sobre la seguretat obtinguda per part del script en segon pla
if(message !== undefined){
	if(message.state === 'secure'){
		
	  json_string.https=true;
	  
	  if(message.protocolVersion !== "unknown" && message !== undefined){
		
		if(message.cipherSuite.toUpperCase().includes("_ANON_"))
			anulacio_puntacio=true; //No s'accepta autenticaió anònima, no obstant els navegadors per defecte no els accepten
		
		let greenCheck = document.getElementById("state_txt");
		greenCheck.setAttribute("src", "../images/OK.png");
		greenCheck.setAttribute("width", "25");
		greenCheck.setAttribute("height", "25");
		greenCheck.setAttribute("alt", "OK");
		greenCheck.setAttribute("verticalAlign","middle");
		
		//Obtenim l'element estrelles
		estrelles = document.getElementById("rating");
		
		if(message.protocolVersion === "TLSv1.3" || message.protocolVersion === "TLSv1.2"){
			
			document.getElementById("protocolVersion_txt").style.color = "green";
			document.getElementById("protocolVersion_txt").innerHTML = message.protocolVersion+"   ";
			
			let greenCheck = document.getElementById("protocolVersion_img");
			greenCheck.setAttribute("src", "../images/OK.png");
			greenCheck.setAttribute("width", "25");
			greenCheck.setAttribute("height", "25");
			greenCheck.setAttribute("alt", "OK");

			
		}
		else if (message.protocolVersion === "TLSv1.1"){
			
			document.getElementById("protocolVersion_txt").style.color = "yellow";
			document.getElementById("protocolVersion_txt").innerHTML = message.protocolVersion+"   ";

			let greenCheck = document.getElementById("protocolVersion_img");
			greenCheck.setAttribute("src", "../images/OK.png");
			greenCheck.setAttribute("width", "25");
			greenCheck.setAttribute("height", "25");
			greenCheck.setAttribute("alt", "OK");

			
		}
		else if (message.protocolVersion === "TLSv1"){
			
			document.getElementById("protocolVersion_txt").style.color = "orange";
			document.getElementById("protocolVersion_txt").innerHTML = message.protocolVersion;	

			let greenCheck = document.getElementById("protocolVersion_img");
			greenCheck.setAttribute("src", "../images/OK.png");
			greenCheck.setAttribute("width", "25");
			greenCheck.setAttribute("height", "25");
			greenCheck.setAttribute("alt", "OK");


			
		}
		else if (message.protocolVersion === "SSLv0.3" || message.protocolVersion === "SSLv0.2" ){
			
			document.getElementById("protocolVersion_txt").style.color = "red";
			document.getElementById("protocolVersion_txt").innerHTML = message.protocolVersion;	

			let greenCheck = document.getElementById("protocolVersion_img");
			greenCheck.setAttribute("src", "../images/KO.png");
			greenCheck.setAttribute("width", "25");
			greenCheck.setAttribute("height", "25");
			greenCheck.setAttribute("alt", "KO");

		}
		
		document.getElementById("cipherSuite_txt").innerHTML = message.cipherSuite; 
		
		if(message.hsts){
			
			let greenCheck = document.getElementById("hsts_txt");
			greenCheck.setAttribute("src", "../images/OK.png");
			greenCheck.setAttribute("width", "25");
			greenCheck.setAttribute("height", "25");
			greenCheck.setAttribute("alt", "OK");
			
		}
		else {			

			let greenCheck = document.getElementById("hsts_txt");
			greenCheck.setAttribute("src", "../images/KO.png");
			greenCheck.setAttribute("width", "25");
			greenCheck.setAttribute("height", "25");
			greenCheck.setAttribute("alt", "KO");
			
		}
		
		if(!message.isDomainMismatch){
			
			let greenCheck = document.getElementById("isDomainMismatch_txt");
			greenCheck.setAttribute("src", "../images/OK.png");
			greenCheck.setAttribute("width", "25");
			greenCheck.setAttribute("height", "25");
			greenCheck.setAttribute("alt", "OK");

			}
		else { 

			let greenCheck = document.getElementById("isDomainMismatch_txt");
			greenCheck.setAttribute("src", "../images/KO.png");
			greenCheck.setAttribute("width", "25");
			greenCheck.setAttribute("height", "25");
			greenCheck.setAttribute("alt", "KO");

		}
		
		if(message.isExtendedValidation){
			
			puntuacioEV=10.0;

			let greenCheck = document.getElementById("isExtendedValidation_txt");
			greenCheck.setAttribute("src", "../images/OK.png");
			greenCheck.setAttribute("width", "25");
			greenCheck.setAttribute("height", "25");
			greenCheck.setAttribute("alt", "OK");
		}
		else{
			
			puntuacioEV=0.0;

			let greenCheck = document.getElementById("isExtendedValidation_txt");
			greenCheck.setAttribute("src", "../images/KO.png");
			greenCheck.setAttribute("width", "25");
			greenCheck.setAttribute("height", "25");
			greenCheck.setAttribute("alt", "KO");
			
		}
		
		if(message.certificateTransparencyStatus == "policy_compliant"){

			//puntuacioCTS=10.0; //Només aplics al certificat del servidor web

			let greenCheck = document.getElementById("isCTS_txt");
			greenCheck.setAttribute("src", "../images/OK.png");
			greenCheck.setAttribute("width", "25");
			greenCheck.setAttribute("height", "25");
			greenCheck.setAttribute("alt", "OK");
			
		}
		else{ 

			//puntuacioCTS=0.0;

			let greenCheck = document.getElementById("isCTS_txt");
			greenCheck.setAttribute("src", "../images/KO.png");
			greenCheck.setAttribute("width", "25");
			greenCheck.setAttribute("height", "25");
			greenCheck.setAttribute("alt", "KO");

		}
		
			
		if(!message.isUntrusted){

			let greenCheck = document.getElementById("isUntrusted_txt");
			greenCheck.setAttribute("src", "../images/OK.png");
			greenCheck.setAttribute("width", "25");
			greenCheck.setAttribute("height", "25");
			greenCheck.setAttribute("alt", "OK");

		}
		
		else{ 

			let greenCheck = document.getElementById("isUntrusted_txt");
			greenCheck.setAttribute("src", "../images/KO.png");
			greenCheck.setAttribute("width", "25");
			greenCheck.setAttribute("height", "25");
			greenCheck.setAttribute("alt", "KO");
			anulacio_puntacio=true;	
		
		}
		
		for (i = 0; i < message.certificates.length; i++) { 
		
			//El certificat web té un tracte diferent ja que la validesa la podem obtenir amb el metode (API nativa) directament com també la firma d'aquest (API NATIVA)
			if(i==0){
		
				//Extreiem dades certificat DER
				var dadesCertificat = dataExtractionCert(message.certificates[i]); 
				
				print_header_cert("----- End-entity Certificate -----", "orange");		

				//Validesa certificat
				if(!message.isNotValidAtThisTime){		

					print_validity_valid(message); puntuacioCERTstatus = 10;
					
				}
				else{
					
					print_validity_INvalid(message); puntuacioCERTstatus=0;
								
				}
				
				puntuacio_web = (pes_certStatus*puntuacioCERTstatus) + (pes_PK*puntuacioClauPublica) + (pes_SIG*puntuacioSignature); // puntuació total certificat web
				puntuacio_cadena_certificats += (pes_certWEB*puntuacio_web); //acumulem puntuació per a la cadena de certificats
				
				//JSON local
				json_string.scores.chainCertificates.certificates.certificateWeb.publicKey.name=dadesCertificat.algoritmeClauPublica;
				json_string.scores.chainCertificates.certificates.certificateWeb.publicKey.score=puntuacioClauPublica;
				json_string.scores.chainCertificates.certificates.certificateWeb.publicKey.weight=pes_PK;
			
				json_string.scores.chainCertificates.certificates.certificateWeb.signature.name=dadesCertificat.algoritmeFirmaUsat;
				json_string.scores.chainCertificates.certificates.certificateWeb.signature.score=puntuacioSignature;
				json_string.scores.chainCertificates.certificates.certificateWeb.signature.weight=pes_SIG;
				
				json_string.scores.chainCertificates.certificates.certificateWeb.valid.value=!message.isNotValidAtThisTime;
				json_string.scores.chainCertificates.certificates.certificateWeb.valid.weight=pes_certStatus;
				json_string.scores.chainCertificates.certificates.certificateWeb.score=	puntuacio_web;
				json_string.scores.chainCertificates.certificates.certificateWeb.weight=pes_certWEB;
				json_string.scores.chainCertificates.certificates.certificateWeb.basicConstraints=dadesCertificat.basicConstraints;
			
				if (!message.isNotValidAtThisTime)
					json_string.scores.chainCertificates.certificates.certificateWeb.valid.score=10;
				else json_string.scores.chainCertificates.certificates.certificateWeb.valid.score=0;
				//---------------------------------------------------			
				
			}
			else{
				
				//Extreiem dades certificat en DER
				var dadesCertificat = dataExtractionCert(message.certificates[i]); 
				
				//És l'últim certificat, és a dir, el ROOT, així podem fer comprovació si està instal·lat com a CA en el navegador
				if(i==(message.certificates.length-1)){
					
					//Es troba el certificat en la base de dades de certificats del navegador com a root?
					if(message.certificates[i].isBuiltInRoot){
					
						print_header_cert("---- Root Certificate (Installed) ----","blue");
					
					}	
					else{
						
						print_header_cert("---- Root Certificate (Not installed) ----","red");
						anulacio_puntacio=true; //Si el root no es troba la puntuació serà 0 ja que no es pot confiar en la cadena
					
					}
				
					//JSON local
					json_string.scores.chainCertificates.certificates.certificateCAroot.publicKey.name=dadesCertificat.algoritmeClauPublica;
					json_string.scores.chainCertificates.certificates.certificateCAroot.publicKey.score=puntuacioClauPublica;
					json_string.scores.chainCertificates.certificates.certificateCAroot.publicKey.weight=pes_PK;
					json_string.scores.chainCertificates.certificates.certificateCAroot.signature.name=dadesCertificat.algoritmeFirmaUsat;
					json_string.scores.chainCertificates.certificates.certificateCAroot.signature.score=puntuacioSignature;
					json_string.scores.chainCertificates.certificates.certificateCAroot.signature.weight=pes_SIG;
					json_string.scores.chainCertificates.certificates.certificateCAroot.valid.weight=pes_certStatus;
					json_string.scores.chainCertificates.certificates.certificateCAroot.score=puntuacio_CAs;
					json_string.scores.chainCertificates.certificates.certificateCAroot.weight=pes_certCA; 
					json_string.scores.chainCertificates.certificates.certificateCAroot.basicConstraints=dadesCertificat.basicConstraints;



					//---------------------------------------------------
				
					/* ----------- Validity -------------*/			
					if( (new Date(message.certificates[i].validity.start) <= new Date()) && (new Date(message.certificates[i].validity.end) >= new Date())){
					
						print_validity_valid(message);	puntuacioCERTstatus = 10.0;
						json_string.scores.chainCertificates.certificates.certificateCAroot.valid.score=10;
						json_string.scores.chainCertificates.certificates.certificateCAroot.valid.value=true;				

					}
					else{
					
						print_validity_INvalid(message); puntuacioCERTstatus = 0;
						json_string.scores.chainCertificates.certificates.certificateCAroot.valid.score=0;
						json_string.scores.chainCertificates.certificates.certificateCAroot.valid.value=false;
						
					}

				}
				else{
					
					print_header_cert("----- Intermediate Certificate -----","brown");

					/* ----------- Validity -------------*/			
					if( (new Date(message.certificates[i].validity.start) <= new Date()) && (new Date(message.certificates[i].validity.end) >= new Date())){
					
						print_validity_valid(message);	puntuacioCERTstatus = 10.0;
						json_string.scores.chainCertificates.certificates.certificateCA.valid.score=10;
						json_string.scores.chainCertificates.certificates.certificateCA.valid.value=true;
						

					}
					else{
					
						print_validity_INvalid(message); puntuacioCERTstatus = 0;
						json_string.scores.chainCertificates.certificates.certificateCA.valid.score=0;
						json_string.scores.chainCertificates.certificates.certificateCA.valid.value=false;
						
					}
							
				}
				
				puntuacio_CAs = (pes_certStatus*puntuacioCERTstatus) + (pes_PK*puntuacioClauPublica) + (pes_SIG*puntuacioSignature);
				puntuacio_cadena_certificats += (pes_certCA*puntuacio_CAs);
				
				//JSON local
				json_string.scores.chainCertificates.certificates.certificateCA.publicKey.name=dadesCertificat.algoritmeClauPublica;
				json_string.scores.chainCertificates.certificates.certificateCA.publicKey.score=puntuacioClauPublica;
				json_string.scores.chainCertificates.certificates.certificateCA.publicKey.weight=pes_PK;
				
				json_string.scores.chainCertificates.certificates.certificateCA.signature.name=dadesCertificat.algoritmeFirmaUsat;
				json_string.scores.chainCertificates.certificates.certificateCA.signature.score=puntuacioSignature;
				json_string.scores.chainCertificates.certificates.certificateCA.signature.weight=pes_SIG;
				
				json_string.scores.chainCertificates.certificates.certificateCA.valid.weight=pes_certStatus;
				json_string.scores.chainCertificates.certificates.certificateCA.score=puntuacio_CAs; 
				json_string.scores.chainCertificates.certificates.certificateCA.weight=pes_certROOT;
				
				json_string.scores.chainCertificates.certificates.certificateCA.basicConstraints=dadesCertificat.basicConstraints;

				//---------------------------------------------------
								
			}
			
			//Issuer
			print_issuer(message,dadesCertificat.x509);		
			//Issued 
			print_issued(message,dadesCertificat.x509);
			//DNS
			print_DNS(dadesCertificat);
			//Serial number
			print_serial_number(message)
			//Algoritme firma
			print_algoritme_firma(dadesCertificat);		
			//Clau
			print_PK(dadesCertificat);		
			//Fingerprint					
			print_fingerprints(message);		
			//Indiquem quines extensions són crítiques del certificat		
			print_critical_extensions(dadesCertificat);
			//Usos de la clau (certificat) extensió crítica				
			print_key_usages(dadesCertificat); //TODO comprovar si s'usa amb aquest fi
			//Restriccions del certificat (Entitat final o CA) extensió crítica
			print_basic_constraints(dadesCertificat);
			//Usos de la clau estesos
			print_usos_clau_estesos(dadesCertificat);
			//Acces a la Informació de l'autoritat
			print_aia(dadesCertificat);
				
		}
		
		/* ------------------------------------------------- */
		
		/* -------------- INICIEM CÀLCUL PUNTUACIONS ------------------ */

		//Valor protocol SSL/TLS
		value_protocol_SSL(message);
		//Valor cipher suite
		value_cipher_suite(message);
		//Afegim l'esquema d'autenticació per a l'establiment de la connexió
		if(message.signatureSchemeName !== undefined){ // A vegades la API retorna 'undefined', en aquest cas l'obtenim del ciphersuite
			
			let sigSchemName = message.signatureSchemeName.split("-");
			if(sigSchemName[1] === 'P192')
				document.getElementById("signatureSchemeName_txt").innerHTML = "Elliptic Curve Digital Signature Algorithm" + " 192-bit with " + sigSchemName[2]  ;
			else if(sigSchemName[1] === 'P224')
				document.getElementById("signatureSchemeName_txt").innerHTML = "Elliptic Curve Digital Signature Algorithm" + " 224-bit with " + sigSchemName[2]  ;
			else if(sigSchemName[1] === 'P256')
				document.getElementById("signatureSchemeName_txt").innerHTML = "Elliptic Curve Digital Signature Algorithm" + " 256-bit with " + sigSchemName[2]  ;
			else if(sigSchemName[1] === 'P384')
				document.getElementById("signatureSchemeName_txt").innerHTML = "Elliptic Curve Digital Signature Algorithm" + " 384-bit with " + sigSchemName[2]  ;
			else if(sigSchemName[1] === 'P521')
				document.getElementById("signatureSchemeName_txt").innerHTML = "Elliptic Curve Digital Signature Algorithm" + " 521-bit with " + sigSchemName[2]  ;
			else if(sigSchemName[0] === 'RSA')
				document.getElementById("signatureSchemeName_txt").innerHTML = 'Rivest, Shamir y Adleman (RSA)' +" with "+ sigSchemName[2]  ;
			else 
				document.getElementById("signatureSchemeName_txt").innerHTML =  message.signatureSchemeName ;
		
		}
		else if(sign==='DSS')				
				document.getElementById("signatureSchemeName_txt").innerHTML = 'Digital Signature Standard' ;
		else if(sign.toUpperCase()==='ANON')
				document.getElementById("signatureSchemeName_txt").innerHTML = 'Anonymous' ;
		else {
			document.getElementById("signatureSchemeName_txt").innerHTML = sign ;
		};
		
		//Sumem puntuacio de cada propietat del CPS
		puntuacioCPS = (pes_TLS*puntuacioProto_TLS) + (pes_KE*puntuacioKE) + (pes_BC*puntuacioBC) + (pes_SIGAUTH*puntuacioAUTH) + (pes_Hash*puntuacioHash);
		
		//Càlcul total connexió
		puntuacio_connexio = (pes_CPS*puntuacioCPS) + (puntuacioEV*pes_EV) + (pes_PFS*pfs);

		if(anulacio_puntacio) puntuacioTOTAL = 0; //Alguna comprovació anterior ha fet que la puntuació sigui 0 tals com domini i cadena de certificació
		else puntuacioTOTAL = (pes_connexio*puntuacio_connexio)+ (pes_cadena_certificats*puntuacio_cadena_certificats);
		
		//Imprimim puntuació total
		print_total_score(puntuacioTOTAL);
		//Imprimim si usa PFS
		print_pfs();
		//Imprimim les estrelles (rating)
		print_estrelles();
		//Afegim puntuacions en els punts determinats del popup
		print_puntuacions();
		
		//Omplim el JSON per emmagatzemar-lo localment
		
		json_string.score= puntuacioTOTAL;
		//Critics
		json_string.critics.domainMatches=!message.isDomainMismatch;
		json_string.critics.trustable=!message.isUntrusted
		//Connection
		json_string.scores.connection.weight=pes_connexio;
		json_string.scores.connection.score=puntuacio_connexio;
		//CPS
		json_string.scores.connection.weight=pes_connexio;
		json_string.scores.connection.cipherSuite.weight=pes_CPS;
		json_string.scores.connection.cipherSuite.value=message.cipherSuite;
		json_string.scores.connection.cipherSuite.score=puntuacioCPS;
		//EV
		json_string.scores.connection.extendedValidation.weight=pes_EV;
		if(message.isExtendedValidation) json_string.scores.connection.extendedValidation.score=10;
		else json_string.scores.connection.extendedValidation.score=0;
		//CTS
		json_string.scores.connection.certificateTransparency.name=message.certificateTransparencyStatus;
		//PFS
		json_string.scores.connection.perfectForwardSecrecy.weight=pes_PFS;
		json_string.scores.connection.perfectForwardSecrecy.score=pfs;
		//cipherSuite
		json_string.scores.connection.cipherSuite.weight=pes_CPS;
		json_string.scores.connection.cipherSuite.score = puntuacioCPS;
		
		json_string.scores.connection.cipherSuite.protocol.name=message.protocolVersion;
		json_string.scores.connection.cipherSuite.protocol.score=puntuacioProto_TLS;
		json_string.scores.connection.cipherSuite.protocol.weight=pes_TLS;	
		
		json_string.scores.connection.cipherSuite.keyExchange.name=KE;
		json_string.scores.connection.cipherSuite.keyExchange.score=puntuacioKE;
		json_string.scores.connection.cipherSuite.keyExchange.weight=pes_KE;

		json_string.scores.connection.cipherSuite.signature.name=message.signatureSchemeName;
		json_string.scores.connection.cipherSuite.signature.score=puntuacioAUTH;
		json_string.scores.connection.cipherSuite.signature.weight=pes_SIGAUTH;
		
		json_string.scores.connection.cipherSuite.bulkCipher.name=BC;
		json_string.scores.connection.cipherSuite.bulkCipher.score=puntuacioBC;
		json_string.scores.connection.cipherSuite.bulkCipher.AEAD=AEAD;
		json_string.scores.connection.cipherSuite.bulkCipher.weight=pes_BC;
		
		json_string.scores.connection.cipherSuite.MAChash.name=hash;
		json_string.scores.connection.cipherSuite.MAChash.score=puntuacioHash;
		json_string.scores.connection.cipherSuite.MAChash.weight=pes_Hash;
		
		//chainCertificates
		json_string.scores.chainCertificates.weight=pes_cadena_certificats;
		json_string.scores.chainCertificates.score=puntuacio_cadena_certificats;
		json_string.url=URL_short;
		//La emmagatzem a la memòria local
		store_local_values(json_string);
		 
	  }else {
		document.getElementById("tot").innerHTML="Error en el protocol o en obtenir la informació del protcol SSL/TLS. No es pot determinar la seguretat de la connexió.";
	  }	  

  
	

	}
	else if (message.state === 'insecure'){
	
		json_string.https=false;
		var tot = document.getElementById("tot"); 
		tot.innerHTML=""; 
		var a = document.createElement('a'); 
		var url_nova = tab.url; 
		if(url_nova.includes("http://")) url_nova = url_nova.replace('http://','https://');
		a.setAttribute('href', url_nova); a.appendChild(document.createTextNode(url_nova)); 
		tot.appendChild(document.createElement('p').appendChild(document.createTextNode("Your connection is not secure. Try it at ")));
		tot.appendChild(a);
    
	}
	else if (message.state === 'broken' || message.state === 'weak' ){
	
		json_string.https=false;
		var tot = document.getElementById("tot"); 
		tot.innerHTML=""; 
		tot.appendChild(document.createElement('p').appendChild(document.createTextNode("Error in the handshake or security too weak.")));
	}
}
else{
		json_string.https=false;
		var tot = document.getElementById("tot"); 
		tot.innerHTML=""; 
		var a = document.createElement('a'); 
		var url_nova = tab.url; 
		if(url_nova.includes("http://")) url_nova = url_nova.replace('http://','https://');
		a.setAttribute('href', url_nova); a.appendChild(document.createTextNode(url_nova)); 
		tot.appendChild(document.createElement('p').appendChild(document.createTextNode("Your connection is not secure. Try it at ")));
		tot.appendChild(a);
}	
});

//Obtenim la tab activa
browser.tabs.query({currentWindow: true, active: true}).then(logTabs, onError);
  
// Funcions -------------------------------------------------
function dataExtractionCert (certificat) {

			//Parsing el certificat
			let parsedCert = new Uint8Array(certificat.rawDER);
		  
			// parse the DER
			let asn1 = asn1js.fromBER(parsedCert.buffer);
			let x509 = new Certificate({ schema: asn1.result });
			x509 = x509.toJSON()

			// ens permetrà extreure les extension crítiques
			let criticalExtensions = [];
			x509.extensions.forEach(ext => {
			if (ext.hasOwnProperty('critical') && ext.critical === true) {
			  criticalExtensions.push(ext.extnID);
			}
			});
								  
			//Obtenim els usos de la clau ------------------------------------------------
			let keyUsages = {
				critical: criticalExtensions.includes('2.5.29.15'),
				purposes: [],
			};
							
			let keyUsagesBS = getX509Ext(x509.extensions, '2.5.29.15').parsedValue;
			if (keyUsagesBS !== undefined) {
			
			let unusedBits = keyUsagesBS.valueBlock.unusedBits;
			keyUsagesBS = parseInt(keyUsagesBS.valueBlock.valueHex, 16) >> unusedBits;
			
			strings.keyUsages.slice(unusedBits - 1).forEach(usage => {
			if (keyUsagesBS & 1) {
				keyUsages.purposes.push(usage);
			}
				keyUsagesBS = keyUsagesBS >> 1;
			})
			
				keyUsages.purposes.reverse();
			};
			
			//------------------------------------------------------------------------------

			//Obtenim restriccions del certificat
			
			let basicConstraints = getX509Ext(x509.extensions, '2.5.29.19');
			if (basicConstraints && basicConstraints.parsedValue) {
				basicConstraints = {
					cA: (basicConstraints.parsedValue.cA !== undefined && basicConstraints.parsedValue.cA),
					critical: criticalExtensions.includes('2.5.29.19'),
				};
			 }
			
			//--------------------------------------------------------------------		
			
			//Obtenim ús millorat de claus   (extended) --------------------------------------------
				
			let eKeyUsages;
			if(getX509Ext(x509.extensions, '2.5.29.37')!==undefined && getX509Ext(x509.extensions, '2.5.29.37').extnValue!== undefined){
				eKeyUsages = getX509Ext(x509.extensions, '2.5.29.37').parsedValue;
					if (eKeyUsages !== undefined) {
					eKeyUsages = {
						critical: criticalExtensions.includes('2.5.29.37'),
						purposes: eKeyUsages.keyPurposes.map(x => strings.eKU[x]),
					}
					}					
			
			}
			else eKeyUsages = undefined;
			//---------------------------------------------------------------------------	

			//Obtenim Authority Information Access (AIA)
			let aia = getX509Ext(x509.extensions, '1.3.6.1.5.5.7.1.1').parsedValue;
			if (aia) {
			aia = aia.accessDescriptions.map(x => {
			  return {
				location: x.accessLocation.value,
				method: strings.aia[x.accessMethod],
			  };
			});
			}

			aia = {
				descriptions: aia,
				critical: criticalExtensions.includes('1.3.6.1.5.5.7.1.1'),
			}			
			
			// get the subjectAltNames
			let san = getX509Ext(x509.extensions, '2.5.29.17').parsedValue;
			if (san && san.hasOwnProperty('altNames')) {
				san = Object.keys(san.altNames).map(x => {
				  const type = san.altNames[x].type;

				  switch (type) {
					case 4:  // directori
					  return [strings.san[type], parseSubsidiary(san.altNames[x].value.typesAndValues).dn]
					case 7:  // adreça IP
					  let address = san.altNames[x].value.valueBlock.valueHex;

					  if (address.length === 8) {  // ipv4
						return [strings.san[type], address.match(/.{1,2}/g).map(x => parseInt(x, 16)).join('.')];
					  } else if (address.length === 32) {  // ipv6
						return [strings.san[type], address.toLowerCase().match(/.{1,4}/g).join(':').replace(/\b:?(?:0+:?){2,}/, '::')];
					  } else {
						return [strings.san[type], 'Unknown IP address'];
					  }
					default:
					  //return [strings.san[type], san.altNames[x].value] Si volem el tipus
					  return [san.altNames[x].value]
				  }
				});
			} else {
				san = [];
			}

			san = {
				altNames: san,
				critical: criticalExtensions.includes('2.5.29.17'),
			};
	
	
			// public key info, ens interesa el kty i el keysize
			let spki = Object.assign({
				crv: undefined,
				e: undefined,
				kty: undefined,
				n: undefined,
				keysize: undefined,
				x: undefined,
				xy: undefined,
				y: undefined,
			}, x509.subjectPublicKeyInfo);
			
			//----------------------------Funcions per descodificar -----------------------------
		  
			const b64urltodec = (b64) => {
			return new asn1js.Integer({ valueHex: stringToArrayBuffer(fromBase64('AQAB', true, true)) }).valueBlock._valueDec;
			};
		  
			const b64urltohex = (b64) => {
			const hexBuffer = new asn1js.Integer({ valueHex: stringToArrayBuffer(fromBase64(b64, true, true)) }).valueBlock._valueHex;
			const hexArray = Array.from(new Uint8Array(hexBuffer));

			return hexArray.map(b => ('00' + b.toString(16)).slice(-2));
			};
			//------------------------------------------------------------------------------------
		  
			//Obtenim la mida de la clau pública que s'ha usat per part del CA per crear-la

			if (spki.kty === 'RSA') {
				spki.e = b64urltodec(spki.e);                      // exponent  
				spki.keysize = b64urltohex(spki.n).length * 8;     // mida clau en bits
				if(spki.keysize === 1024) puntuacioClauPublica = 4.0;
				else if(spki.keysize === 2048) puntuacioClauPublica = 9.0;
				else if(spki.keysize === 3072) puntuacioClauPublica = 10.0;
				else if(spki.keysize === 7680) puntuacioClauPublica = 10.0;
				else if(spki.keysize >= 15360) puntuacioClauPublica = 10.0;

			} else if (spki.kty === 'EC') {
				spki.kty = 'Elliptic Curve';
				spki.keysize = parseInt(spki.crv.split('-')[1])    // mida clau 
				if(spki.keysize >= 160 && spki.keysize < 224) puntuacioClauPublica = 4.0;
				else if(spki.keysize >= 224 && spki.keysize < 256) puntuacioClauPublica = 9.0;
				else if(spki.keysize >= 256 && spki.keysize < 384) puntuacioClauPublica = 10.0;
				else if(spki.keysize >= 384 && spki.keysize < 512) puntuacioClauPublica = 10.0;
				else if(spki.keysize >= 512) puntuacioClauPublica = 10.0;

			}
			
			let algoritmeClauPublica = spki.kty +" "+spki.keysize+"-bit";
			//Extreiem puntuació de l'algoritme que s'ha usat per firmar el certificat
			puntuacioSignature = AlgoritmeSignature[x509.signatureAlgorithm.algorithmId].score;
			let algoritmeFirmaUsat = AlgoritmeSignature[x509.signatureAlgorithm.algorithmId].desc;
			
			return {
				
				x509: x509,
				criticalExtensions: criticalExtensions,
				keyUsages: keyUsages,
				basicConstraints: basicConstraints,
				eKeyUsages: eKeyUsages,
				aia: aia,
				spki: spki,
				san : san,
				algoritmeFirmaUsat: algoritmeFirmaUsat,
				algoritmeClauPublica : algoritmeClauPublica
				
			};

}
//Obtenim informació de la TAB actual
function logTabs(tabs) {
    tab = tabs[0]; 
};
//Obtenir el error
function onError(err){
    console.error(err);
};

//Funció per obtenir l'extensió determinada
var getX509Ext = (extensions, v) => {
  for (var extension in extensions) {
    if (extensions[extension].extnID === v) {
      return extensions[extension];
    }
  }

  return {
    extnValue: undefined,
    parsedValue: undefined,
  };

};

//Converteix un node en negreta i lletres grans
function bold_size_text_TextNodeLarge(paraula){
	
	let nodeParaula = document.createTextNode(paraula);
	let span = document.createElement('span');
	
	span.style.fontSize = "medium";
	span.style.fontWeight = "900";	

	span.appendChild(nodeParaula);
	
	return span;
}

//Converteix un node en negreta i lletres grans
function bold_size_text_TextNodeMid(paraula){
	
	let nodeParaula = document.createTextNode(paraula);
	let span = document.createElement('span');
	
	span.style.fontSize = "small";
	span.style.fontWeight = "900";	

	span.appendChild(nodeParaula);
	
	return span;
}

function print_puntuacions(){

	document.getElementById("sscore_cps").innerHTML="("+(Math.round(puntuacioCPS*100))/100+"/10)";
	document.getElementById("sscore_proto").innerHTML="("+(Math.round(puntuacioProto_TLS*100))/100+"/10)";
	document.getElementById("sscore_ke").innerHTML="("+(Math.round(puntuacioKE*100))/100+"/10)";
	document.getElementById("sscore_bc").innerHTML="("+(Math.round(puntuacioBC*100))/100+"/10)";
	document.getElementById("sscore_pfs").innerHTML="("+(Math.round(pfs*100))/100+"/10)";
	document.getElementById("sscore_hash").innerHTML="("+(Math.round(puntuacioHash*100))/100+"/10)";
	document.getElementById("sscore_ev").innerHTML="("+(Math.round(puntuacioEV*100))/100+"/10)";
	document.getElementById("sscore_sigAuth").innerHTML="("+(Math.round(puntuacioAUTH*100))/100+"/10)";
	//document.getElementById("sscore_cts").innerHTML="("+(Math.round(puntuacioCTS*100))/100+"/10)";
	document.getElementById("sscore_chain").innerHTML="("+(Math.round(puntuacio_cadena_certificats*100))/100+"/10)";

}

function print_usos_clau_estesos(dadesCertificat){

	if(dadesCertificat.eKeyUsages !== undefined && dadesCertificat.eKeyUsages !== null && dadesCertificat !== undefined){

		if(dadesCertificat.eKeyUsages.purposes.length>0 && dadesCertificat.eKeyUsages.purposes !==undefined){
			
			if(dadesCertificat.eKeyUsages.critical){
				
				node_tmp = bold_size_text_TextNodeLarge("Extended key usages "+ criticExtension);
				p_tmp = document.createElement("p");				
				p_tmp.appendChild(node_tmp);
				document.body.appendChild(p_tmp);
				
			}
			else{

				node_tmp = bold_size_text_TextNodeLarge("Extended key usages: ");
				p_tmp = document.createElement("p");				
				p_tmp.appendChild(node_tmp);
				document.body.appendChild(p_tmp);
			
			}
			
			for(let purposeEkeyVar in dadesCertificat.eKeyUsages.purposes){
		
				p_tmp = document.createElement("p");
				p_tmp.style.marginLeft = "15px";
				p_tmp.appendChild(document.createTextNode(dadesCertificat.eKeyUsages.purposes[purposeEkeyVar]));
				document.body.appendChild(p_tmp);

			}
			
		}	
	
	}

}

function print_validity_valid(message){
	

	if( (new Date(message.certificates[i].validity.start) <= new Date()) && (new Date(message.certificates[i].validity.end) >= new Date())){
	
		let p_val = document.createElement("p");
		p_val.style.color="green";
		p_val.style.textAlign="center";
		
		let img_node = document.createElement("img");
		img_node.style.verticalAlign = "middle"; 
		img_node.setAttribute("src", "../images/OK.png");
		img_node.setAttribute("width", "25");
		img_node.setAttribute("height", "25");
		img_node.setAttribute("alt", "OK");	
		img_node.setAttribute("verticalAlign","middle");
		let span_valid1 =document.createElement("span");
		span_valid1.style.verticalAlign = "middle";
		span_valid1.appendChild(document.createTextNode("Certificate is valid    "));
		p_val.appendChild(span_valid1);
		p_val.appendChild(img_node);
		document.body.appendChild(p_val);
	
	}
	else{
	
		let p_val = document.createElement("p");
		p_val.style.color="red";
		p_val.style.verticalAlign = "middle"; 
		p_val.style.textAlign="center";
		
		let img_node = document.createElement("img");
		img_node.style.verticalAlign = "middle"; 
		img_node.setAttribute("src", "../images/KO.png");
		img_node.setAttribute("width", "25");
		img_node.setAttribute("height", "25");
		img_node.setAttribute("alt", "KO");	
		img_node.setAttribute("verticalAlign","middle");
		let span_valid1 =document.createElement("span");
		span_valid1.style.verticalAlign = "middle";
		span_valid1.appendChild(document.createTextNode("Certificate is not valid    "));
		p_val.appendChild(span_valid1);
		p_val.appendChild(img_node);		
		document.body.appendChild(p_val);

	}

	let end = moment(new Date(message.certificates[i].validity.end));
	end.locale(navigator.language);
	
	let start = moment(new Date(message.certificates[i].validity.start));
	start.locale(navigator.language);

	node_tmp = bold_size_text_TextNodeLarge("Start:  ");
	p_tmp = document.createElement("p");				
	p_tmp.appendChild(node_tmp);
	p_tmp.appendChild(document.createTextNode(start.format("DD-MM-YYYY HH:mm:ss")+". Started "+ start.startOf('day').fromNow()));
	document.body.appendChild(p_tmp);
	
	node_tmp = bold_size_text_TextNodeLarge("End:  ");
	p_tmp = document.createElement("p");				
	p_tmp.appendChild(node_tmp);
	p_tmp.appendChild(document.createTextNode(end.format("DD-MM-YYYY HH:mm:ss")+". Expires "+ end.endOf('day').fromNow()));							
	document.body.appendChild(p_tmp);
	
	return;

}

function print_validity_INvalid(message){
	
	if( (new Date(message.certificates[i].validity.start) <= new Date()) && (new Date(message.certificates[i].validity.end) >= new Date())){
	
		let p_val = document.createElement("p");
		p_val.style.color="green";
		p_val.style.verticalAlign = "middle";
		p_val.style.textAlign="center";
		
		
		let img_node = document.createElement("img");
		img_node.style.verticalAlign = "middle"; 
		img_node.setAttribute("src", "../images/OK.png");
		img_node.setAttribute("width", "25");
		img_node.setAttribute("height", "25");
		img_node.setAttribute("alt", "OK");
		img_node.setAttribute("verticalAlign","middle");
		let span_valid1 =document.createElement("span");
		span_valid1.style.verticalAlign = "middle";
		span_valid1.appendChild(document.createTextNode("Certificate is valid    "));
		p_val.appendChild(span_valid1);
		p_val.appendChild(img_node);
		
		document.body.appendChild(p_val);
		document.body.appendChild(document.createElement("BR"));
		document.body.appendChild(document.createElement("BR"));
	
	}
	else{
	
		let p_val = document.createElement("p");
		p_val.style.color="red";
		p_val.style.verticalAlign = "middle"; 
		p_val.style.textAlign="center";
		
		let img_node = document.createElement("img");
		img_node.style.verticalAlign = "middle"; 
		img_node.setAttribute("src", "../images/KO.png");
		img_node.setAttribute("width", "25");
		img_node.setAttribute("height", "25");
		img_node.setAttribute("alt", "KO");	
		img_node.setAttribute("verticalAlign","middle");
		let span_valid1 =document.createElement("span");
		span_valid1.style.verticalAlign = "middle";
		span_valid1.appendChild(document.createTextNode("Certificate is not valid    "));
		p_val.appendChild(span_valid1);
		p_val.appendChild(img_node);
		
		document.body.appendChild(p_val);
		document.body.appendChild(document.createElement("BR"));
		document.body.appendChild(document.createElement("BR"));

	}
	
	let start = moment(new Date(message.certificates[i].validity.start));
	start.locale(navigator.language );
	
	let end = moment(new Date(message.certificates[i].validity.end));
	end.locale(navigator.language);

	if(new Date(message.certificates[i].validity.start > new Date())){
	
		node_tmp = bold_size_text_TextNodeLarge("Start:  ");
		p_tmp = document.createElement("p");				
		p_tmp.appendChild(node_tmp);
		p_tmp.appendChild(document.createTextNode(start.format("DD-MM-YYYY HH:mm:ss")+". Starts "+ start.startOf('day').fromNow()));
		document.body.appendChild(p_tmp);
		
		node_tmp = bold_size_text_TextNodeLarge("End:  ");
		p_tmp = document.createElement("p");				
		p_tmp.appendChild(node_tmp);
		p_tmp.appendChild(document.createTextNode(end.format("DD-MM-YYYY HH:mm:ss")+". Expired "+ end.endOf('day').fromNow()));							
		document.body.appendChild(p_tmp);
	
	}
	else if (new Date(message.certificates[i].validity.end < new Date())){

		node_tmp = bold_size_text_TextNodeLarge("Start:  ");
		p_tmp = document.createElement("p");				
		p_tmp.appendChild(node_tmp);
		p_tmp.appendChild(document.createTextNode(start.format("DD-MM-YYYY HH:mm:ss")+". Started "+ start.startOf('day').fromNow()));
		document.body.appendChild(p_tmp);
		
		node_tmp = bold_size_text_TextNodeLarge("End:  ");
		p_tmp = document.createElement("p");				
		p_tmp.appendChild(node_tmp);
		p_tmp.appendChild(document.createTextNode(end.format("DD-MM-YYYY HH:mm:ss")+". Expired "+ end.endOf('day').fromNow()));							
		document.body.appendChild(p_tmp);	

	}

	return;

}

function print_DNS(dadesCertificat){

	if (dadesCertificat.san.altNames.length>0 && dadesCertificat.san.altNames !== undefined && dadesCertificat.san !== undefined){
	
		let DNScriticExt;
		if(dadesCertificat.san.critical) DNScriticExt = "Alternative names (critical extension):  ";
		else DNScriticExt = "Alternative names:  ";
		
		let node_dns = bold_size_text_TextNodeLarge(DNScriticExt);
		let dns_tmp = document.createElement("p");				
		dns_tmp.appendChild(node_dns);
				
		for (let san_names in dadesCertificat.san.altNames){
		
			let dns2_tmp = document.createElement("span");
			dns_tmp.appendChild(dns2_tmp.appendChild(document.createTextNode(dadesCertificat.san.altNames[san_names]+ "  ")));			
			document.body.appendChild(dns_tmp);
			
		}

	}

}

function print_basic_constraints(dadesCertificat){

	if(dadesCertificat.basicConstraints.cA !== undefined && dadesCertificat.basicConstraints !== undefined){
		
		if(i==0){

			if(!dadesCertificat.basicConstraints.cA){
			
				node_tmp = bold_size_text_TextNodeLarge("Certificate constraints (critical extension):      ");
				node_tmp.style.verticalAlign = "middle";
				p_tmp = document.createElement("p");
				p_tmp.style.verticalAlign = "middle"; 
				p_tmp.appendChild(node_tmp);
				
				let p2_tmp = document.createElement("span");
				p2_tmp.style.marginLeft = "15px";
				p2_tmp.style.marginRight = "15px";
				p2_tmp.style.verticalAlign = "middle";
				
				let img_node = document.createElement("img");
				img_node.setAttribute("src", "../images/OK.png");
				img_node.setAttribute("width", "25");
				img_node.setAttribute("height", "25");
				img_node.setAttribute("alt", "OK");	
				img_node.setAttribute("verticalAlign","middle");
				img_node.style.verticalAlign="middle";
															
				p2_tmp.appendChild(document.createTextNode("End-entity      "))
				p_tmp.appendChild(p2_tmp);
				p_tmp.appendChild(img_node);
				document.body.appendChild(p_tmp);

				
			}else{
				
				node_tmp = bold_size_text_TextNodeLarge("Certificate constrains (critical extension): ");
				node_tmp.style.verticalAlign = "middle";
				p_tmp = document.createElement("p");			
				p_tmp.style.verticalAlign = "middle"; 
				p_tmp.appendChild(node_tmp);
				
				let p2_tmp = document.createElement("span");
				p2_tmp.style.marginLeft = "15px";
				p2_tmp.style.marginRight = "15px";
				p2_tmp.style.verticalAlign = "middle";
				
				let img_node = document.createElement("img");
				img_node.setAttribute("src", "../images/OK.png");
				img_node.setAttribute("width", "25");
				img_node.setAttribute("height", "25");
				img_node.setAttribute("alt", "OK");
				img_node.setAttribute("verticalAlign","middle");
				img_node.style.verticalAlign="middle";
															
				p2_tmp.appendChild(document.createTextNode("Certification Authority (CA)     "));
				p_tmp.appendChild(p2_tmp);
				p_tmp.appendChild(img_node);
				document.body.appendChild(p_tmp)
				anulacio_puntacio=true; //No té cap sentit que un certificat CA per firmar actui com a entitat final
				 	
			}		
		
		}
		else{
		
			if(!dadesCertificat.basicConstraints.cA){
			
				node_tmp = bold_size_text_TextNodeLarge("Basic constraints (critical extension):      ");
				node_tmp.style.verticalAlign = "middle";
				p_tmp = document.createElement("p");
				p_tmp.style.verticalAlign = "middle"; 
				p_tmp.appendChild(node_tmp);
				
				let p2_tmp = document.createElement("span");
				p2_tmp.style.marginLeft = "15px";
				p2_tmp.style.marginRight = "15px";
				p2_tmp.style.verticalAlign = "middle";
				
				let img_node = document.createElement("img");
				img_node.setAttribute("src", "../images/KO.png");
				img_node.setAttribute("width", "25");
				img_node.setAttribute("height", "25");
				img_node.setAttribute("alt", "KO");
				img_node.setAttribute("verticalAlign","middle");
				img_node.style.verticalAlign="middle";
															
				p2_tmp.appendChild(document.createTextNode("End-entity      "));
				p_tmp.appendChild(p2_tmp);
				p_tmp.appendChild(img_node);
				document.body.appendChild(p_tmp);
				anulacio_puntacio=true; //No té cap sentit que un certificat CA per firmar actui com a entitat final

				
			}else{
				
				node_tmp = bold_size_text_TextNodeLarge("Basic constraints (critical extension): ");
				node_tmp.style.verticalAlign = "middle";
				p_tmp = document.createElement("p");
				p_tmp.style.verticalAlign = "middle"; 
				p_tmp.appendChild(node_tmp);
				
				let p2_tmp = document.createElement("span");
				p2_tmp.style.marginLeft = "15px";
				p2_tmp.style.verticalAlign = "middle";
				
				let img_node = document.createElement("img");
				img_node.style.verticalAlign="middle";
				img_node.setAttribute("src", "../images/OK.png");
				img_node.setAttribute("width", "25");
				img_node.setAttribute("height", "25");
				img_node.setAttribute("alt", "OK");	
				img_node.setAttribute("verticalAlign","middle");
															
				p2_tmp.appendChild(document.createTextNode("Certification Authority (CA)     "));
				p_tmp.appendChild(p2_tmp);
				p_tmp.appendChild(img_node);

				document.body.appendChild(p_tmp)
				 	
			}				
		}	
	}	
		
	return;

}

function print_aia(dadesCertificat){

	if(dadesCertificat.aia.critical !== undefined && dadesCertificat.aia.descriptions !== undefined && dadesCertificat.aia !== undefined){
		
		if(dadesCertificat.aia.critical){
		
			node_tmp = bold_size_text_TextNodeLarge("Authority Information Access "+criticExtension);
			p_tmp = document.createElement("p");
			
			document.body.appendChild(p_tmp.appendChild(node_tmp));
			document.body.appendChild(document.createElement("BR"));
			document.body.appendChild(document.createElement("BR"));
		
		}
		else {
			
			node_tmp = bold_size_text_TextNodeLarge("Authority Information Access:");
			p_tmp = document.createElement("p");
			
			document.body.appendChild(p_tmp.appendChild(node_tmp));
		
		}
		
		let k =0;

		for(k=0; k<dadesCertificat.aia.descriptions.length;k++){

			node_tmp = bold_size_text_TextNodeLarge("· Method: ");
			p_tmp = document.createElement("p");
			p_tmp.style.marginLeft="10px";						
			p_tmp.appendChild(node_tmp);
			p_tmp.appendChild(document.createTextNode(dadesCertificat.aia.descriptions[k].method));
			let node3_tmp = bold_size_text_TextNodeLarge("Location: ");
			node3_tmp.style.marginLeft="10px";		
			p_tmp.appendChild(node3_tmp);
			p_tmp.appendChild(document.createTextNode(dadesCertificat.aia.descriptions[k].location));			
			document.body.appendChild(p_tmp);

		}
	
	}
}

function print_key_usages(dadesCertificat){

	if(dadesCertificat.keyUsages.critical !== undefined && dadesCertificat.keyUsages.purposes !== undefined && dadesCertificat.keyUsages !== undefined){
						
		if(dadesCertificat.keyUsages.critical){
			
			node_tmp = bold_size_text_TextNodeLarge("Key usages "+criticExtension);
			p_tmp = document.createElement("p");	
			p_tmp.appendChild(node_tmp);											
			document.body.appendChild(p_tmp);
			
		}
		else{

			node_tmp = bold_size_text_TextNodeLarge("Key usages:");
			p_tmp = document.createElement("p");
			p_tmp.appendChild(node_tmp);						
			document.body.appendChild(p_tmp);
							
		}
		
		let purposeVar;
		for(purposeVar in dadesCertificat.keyUsages.purposes){
			
			let xp_tmp = document.createElement("p");
			xp_tmp.style.marginLeft = "15px";
			
			if(dadesCertificat.keyUsages.purposes[purposeVar] === 'Digital Signature' && !dadesCertificat.basicConstraints.cA){
				//Ens interessa mostrar que la clau del certificat de l'entitat final té el propòsit de firmar 
				let issuerP_check = document.createElement("img");
				issuerP_check.style.marginLeft="15px";					
				issuerP_check.style.verticalAlign="middle";
				issuerP_check.setAttribute("src", "../images/OK.png");
				issuerP_check.setAttribute("width", "25");
				issuerP_check.setAttribute("height", "25");
				issuerP_check.setAttribute("alt", "OK");
				
				xp_tmp.appendChild(document.createTextNode(dadesCertificat.keyUsages.purposes[purposeVar]));					
				xp_tmp.appendChild(issuerP_check);
				document.body.appendChild(xp_tmp);
			
			}
			else if (dadesCertificat.keyUsages.purposes[purposeVar] === 'Certificate Signing' && dadesCertificat.basicConstraints.cA){
				
				let issuerP_check = document.createElement("img");
				issuerP_check.style.marginLeft="15px";					
				issuerP_check.style.verticalAlign="middle";
				issuerP_check.setAttribute("src", "../images/OK.png");
				issuerP_check.setAttribute("width", "25");
				issuerP_check.setAttribute("height", "25");
				issuerP_check.setAttribute("alt", "OK");
				
				xp_tmp.appendChild(document.createTextNode(dadesCertificat.keyUsages.purposes[purposeVar]));					
				xp_tmp.appendChild(issuerP_check);
				document.body.appendChild(xp_tmp);	
				
			}
			else if (dadesCertificat.keyUsages.purposes[purposeVar] === 'Certificate Signing' && !dadesCertificat.basicConstraints.cA){
				
				let issuerP_check = document.createElement("img");
				issuerP_check.style.marginLeft="15px";					
				issuerP_check.style.verticalAlign="middle";
				issuerP_check.setAttribute("src", "../images/KO.png");
				issuerP_check.setAttribute("width", "25");
				issuerP_check.setAttribute("height", "25");
				issuerP_check.setAttribute("alt", "KO");
				
				xp_tmp.appendChild(document.createTextNode(dadesCertificat.keyUsages.purposes[purposeVar]));					
				xp_tmp.appendChild(issuerP_check);
				document.body.appendChild(xp_tmp);	
				anulacio_puntacio = true; //anulació puntuació				
			}
			else if (dadesCertificat.keyUsages.purposes[purposeVar] !== 'Certificate Signing' && dadesCertificat.keyUsages.purposes[purposeVar] !== 'Digital Signature'){
					
				xp_tmp.appendChild(document.createTextNode(dadesCertificat.keyUsages.purposes[purposeVar]));					
				document.body.appendChild(xp_tmp);		
			}

		}
		
	}
	return;
}

function print_issuer(message,dadesCertificat){

		var issuer = message.certificates[i].issuer;
		var issued = message.certificates[i].subject;
				
		var commonNameIssuer = undefined;
		var organizationIssued = undefined;
		
		for(h =0 ; h < dadesCertificat.issuer.typesAndValues.length; h++){
			if(dadesCertificat.issuer.typesAndValues[h].type == '2.5.4.3') 
				commonNameIssuer = dadesCertificat.issuer.typesAndValues[h].value.valueBlock.value;
				if(commonNameIssuer === undefined) commonNameIssuer="No part of the certificate";
		}
		for(h =0 ; h < dadesCertificat.subject.typesAndValues.length; h++){
			if(dadesCertificat.subject.typesAndValues[h].type == '2.5.4.10') 
				organizationIssued = dadesCertificat.subject.typesAndValues[h].value.valueBlock.value;

		}
		
		if (organizationIssued === undefined){
			for(h =0 ; h < dadesCertificat.subject.typesAndValues.length; h++){
				if(dadesCertificat.subject.typesAndValues[h].type == '2.5.4.3') 
					organizationIssued = dadesCertificat.subject.typesAndValues[h].value.valueBlock.value;		
			}
		}
		let node_tmp;
		
		node_tmp = bold_size_text_TextNodeLarge("Issuer:     ");
		document.body.appendChild(document.createElement("p").appendChild(node_tmp));
		document.body.appendChild(document.createElement("BR"));
		
		j=0;
		
		if(message.certificates[i].isBuiltInRoot && i === message.certificates.length -1) {

			let issuerP_check = document.createElement("img");
			issuerP_check.style.marginLeft="15px";					
			issuerP_check.style.verticalAlign="middle";
			issuerP_check.setAttribute("src", "../images/OK.png");
			issuerP_check.setAttribute("width", "25");
			issuerP_check.setAttribute("height", "25");
			issuerP_check.setAttribute("alt", "OK");

			//Omplim cadena de certificació dels CNs (emissor i emés)
			let element_CN = document.getElementById(id_p_CN[i]);
			element_CN.style.marginLeft="25px";
			let root_span = document.createElement('span');
			let installed_green = document.createElement('span');
			installed_green.style.color="green";
			installed_green.style.marginLeft="5px";
			installed_green.appendChild(document.createTextNode("(Installed)"));
			root_span.appendChild(document.createTextNode(commonNameIssuer+ " ------------> "+organizationIssued));
			root_span.appendChild(installed_green);
			root_span.appendChild(issuerP_check);			
			element_CN.appendChild(root_span);	
			
			let sscore_cert = document.createElement('span');
			sscore_cert.style.color="grey";
			sscore_cert.style.marginLeft="15px";
			sscore_cert.appendChild(document.createTextNode("("+(Math.round(puntuacio_CAs)*100) / 100+"/10)"));
			element_CN.appendChild(sscore_cert);
					
		}
		else if (!message.certificates[i].isBuiltInRoot && i === message.certificates.length -1){
					
			let issuerP_check = document.createElement("img");
			issuerP_check.style.marginLeft="15px";					
			issuerP_check.style.verticalAlign="middle";
			issuerP_check.setAttribute("src", "../images/KO.png");
			issuerP_check.setAttribute("width", "25");
			issuerP_check.setAttribute("height", "25");
			issuerP_check.setAttribute("alt", "KO");

			//Omplim cadena de certificació dels CNs (emissor i emés)
			let element_CN = document.getElementById(id_p_CN[i]);
			element_CN.style.marginLeft="25px";
			let root_span = document.createElement('span');
			let installed_red = document.createElement('span');
			installed_red.style.color="green";
			installed_red.style.marginLeft="5px";
			installed_red.appendChild(document.createTextNode("(Not Installed)"));
			root_span.appendChild(document.createTextNode(commonNameIssuer+ " ------------> "+organizationIssued));
			root_span.appendChild(installed_red);
			root_span.appendChild(issuerP_check);			
			element_CN.appendChild(root_span);			
		
		}
		else if (!message.certificates[i].isBuiltInRoot && i !== message.certificates.length -1){
					
			//Omplim cadena de certificació dels CNs (emissor i emés)
			let element_CN = document.getElementById(id_p_CN[i]);
			element_CN.style.marginLeft="25px";
			element_CN.innerHTML= commonNameIssuer+" ------------ > "+organizationIssued;	
			let sscore_cert = document.createElement('span');
			sscore_cert.style.color="grey";
			sscore_cert.style.marginLeft="15px";
			if(i===0){
				sscore_cert.appendChild(document.createTextNode("("+(Math.round(puntuacio_web)*100 /100)+"/10)"));
			}
			else sscore_cert.appendChild(document.createTextNode("("+(Math.round(puntuacio_CAs)*100 /100)+"/10)"));
			element_CN.appendChild(sscore_cert);
		}			
	
		let issuerP_tmp = document.createElement("p");
		issuerP_tmp.style.marginLeft="15px";	
		issuerP_tmp.style.fontSize="small";
		issuerP_tmp.appendChild(document.createTextNode(message.certificates[i].issuer));
		document.body.appendChild(issuerP_tmp);

}
function print_issued(message,dadesCertificat){

	//Domini coincideix --------------------------------
	
	if(!message.isDomainMismatch){ 
		var domainOK = "   (matched)    ";
	}
	else{
		anulacio_puntacio=true; //Aquí anulem la puntuació ja que és un factor importantíssim que el domini coincideixi
		var domainOK = "   (not matched)   ";
	}
	//--------------------------------------------------
	
	var commonNameIssued = undefined;
	
	for(h =0 ; h < dadesCertificat.subject.typesAndValues.length; h++){
		if(dadesCertificat.subject.typesAndValues[h].type == '2.5.4.3') 
			commonNameIssued = dadesCertificat.subject.typesAndValues[h].value.valueBlock.value;
	}
	
	node_tmp = bold_size_text_TextNodeLarge("Issued:     ");
	document.body.appendChild(document.createElement("p").appendChild(node_tmp));
	document.body.appendChild(document.createElement("BR"));
	
	//Primer element sempre sera el CN			
	
	if(i===0){
		
		let urlP_tmp = bold_size_text_TextNodeMid("  URL visited:  ");
		urlP_tmp.style.marginLeft="15px";
		let subject_p = document.createElement("p");
		subject_p.style.verticalAlign="middle";
		let domainOK_span = document.createElement("span");
		domainOK_span.style.verticalAlign="middle";
		let domainOK_img = document.createElement("img");
		domainOK_img.style.verticalAlign="middle";
		domainOK_img.setAttribute("src", "../images/OK.png");
		domainOK_img.setAttribute("width", "25");
		domainOK_img.setAttribute("height", "25");
		domainOK_img.setAttribute("alt", "OK");	
		domainOK_span.appendChild(document.createTextNode(domainOK));
		domainOK_span.style.fontWeight = "900";
		domainOK_span.appendChild(domainOK_img);

		if(!message.isDomainMismatch){ 
			domainOK_span.style.color="green";
		}
		else domainOK_span.style.color="red";			

		subject_p.style.marginLeft="15px";
		let CN_node = document.createElement('span');
		CN_node.appendChild(document.createTextNode(commonNameIssued+" "));
		CN_node.style.verticalAlign="middle";
		subject_p.appendChild(CN_node);
		subject_p.appendChild(domainOK_span);
		subject_p.appendChild(urlP_tmp);
		let rest_span = document.createElement('span');
		rest_span.appendChild(document.createTextNode(tab.url.substring(8,tab.url.indexOf("/",8))));
		URL_short = tab.url.substring(8,tab.url.indexOf("/",8));
		subject_p.appendChild(rest_span);
		document.body.appendChild(subject_p);
	
	}
	
	let issuerP_tmp = document.createElement("p");
	issuerP_tmp.style.marginLeft="15px";	
	issuerP_tmp.style.fontSize="small";					
	issuerP_tmp.appendChild(document.createTextNode(message.certificates[i].subject));
	document.body.appendChild(issuerP_tmp);
	
	return;
}
function print_serial_number(message){

	let serial_number_p = bold_size_text_TextNodeLarge("Serial number:        ");
	serial_number_p.marginRight="15px";
	serial_number_p.marginLeft="15px";
	
	let serial_text = document.createElement('span');
	serial_text.marginLeft="15px";
	serial_text.marginRight="15px";

	serial_text.appendChild(document.createTextNode(message.certificates[i].serialNumber));
	
	document.body.appendChild(serial_number_p);
	document.body.appendChild(serial_text);
	document.body.appendChild(document.createElement("BR"));
	document.body.appendChild(document.createElement("BR"));
	
	return;
}
function print_algoritme_firma(dadesCertificat){

	let algo_firma_p = bold_size_text_TextNodeLarge("Signature algorithm:     ");
	algo_firma_p.marginRight="15px";
	algo_firma_p.marginLeft="15px";
	
	let algo_firma_text = document.createElement('span');
	algo_firma_text.appendChild(document.createTextNode(dadesCertificat.algoritmeFirmaUsat));
	algo_firma_text.marginLeft="15px";
	algo_firma_text.marginRight="15px";
	algo_firma_text.fontSize="small";
	algo_firma_p.appendChild(algo_firma_text);
	
	let algo_firma_text_sscore = document.createElement('span');
	algo_firma_text_sscore.style.color="grey";
	algo_firma_text_sscore.style.marginLeft="15px";
	algo_firma_text_sscore.innerHTML="("+ ((Math.round(puntuacioSignature)*100) / 100) +"/10)  ";

	if(Math.round(puntuacioSignature) >=8){
		let issuerP_sign_alg = document.createElement("img");
		issuerP_sign_alg.style.marginLeft="15px";					
		issuerP_sign_alg.style.verticalAlign="middle";
		issuerP_sign_alg.setAttribute("src", "../images/OK.png");
		issuerP_sign_alg.setAttribute("width", "25");
		issuerP_sign_alg.setAttribute("height", "25");
		issuerP_sign_alg.setAttribute("alt", "OK");
		algo_firma_text_sscore.appendChild(issuerP_sign_alg);	
	}
	else{
		let issuerP_sign_alg = document.createElement("img");
		issuerP_sign_alg.style.marginLeft="15px";					
		issuerP_sign_alg.style.verticalAlign="middle";
		issuerP_sign_alg.setAttribute("src", "../images/KO.png");
		issuerP_sign_alg.setAttribute("width", "25");
		issuerP_sign_alg.setAttribute("height", "25");
		issuerP_sign_alg.setAttribute("alt", "OK");
		algo_firma_text_sscore.appendChild(issuerP_sign_alg);	
	}
	
	document.body.appendChild(algo_firma_p);
	document.body.appendChild(algo_firma_text);		
	document.body.appendChild(algo_firma_text_sscore);		
	document.body.appendChild(document.createElement("BR"));	
	document.body.appendChild(document.createElement("BR"));	

}	
function print_PK(dadesCertificat){

	let algo_pk_p = bold_size_text_TextNodeLarge("Public key algorithm:     ");
	algo_pk_p.marginRight="15px";
	algo_pk_p.marginLeft="15px";
	let algo_pk_text = document.createTextNode(dadesCertificat.algoritmeClauPublica);
	algo_pk_text.marginLeft="15px";
	algo_pk_text.marginRight="15px";
	algo_pk_text.fontSize="small";
	algo_pk_p.appendChild(algo_pk_text);
	
	let algo_pk_sscore = document.createElement('span');
	algo_pk_sscore.style.color="grey";
	algo_pk_sscore.style.marginLeft="15px";
	algo_pk_sscore.innerHTML="("+ ((Math.round(puntuacioClauPublica)*100) / 100) +"/10)  ";
	
	if(Math.round(puntuacioClauPublica) >=8 ){
		let issuerP_PK_alg = document.createElement("img");
		issuerP_PK_alg.style.marginLeft="15px";					
		issuerP_PK_alg.style.verticalAlign="middle";
		issuerP_PK_alg.setAttribute("src", "../images/OK.png");
		issuerP_PK_alg.setAttribute("width", "25");
		issuerP_PK_alg.setAttribute("height", "25");
		issuerP_PK_alg.setAttribute("alt", "OK");
		algo_pk_sscore.appendChild(issuerP_PK_alg);		
	}
	else{
		let issuerP_PK_alg = document.createElement("img");
		issuerP_PK_alg.style.marginLeft="15px";					
		issuerP_PK_alg.style.verticalAlign="middle";
		issuerP_PK_alg.setAttribute("src", "../images/KO.png");
		issuerP_PK_alg.setAttribute("width", "25");
		issuerP_PK_alg.setAttribute("height", "25");
		issuerP_PK_alg.setAttribute("alt", "OK");
		algo_pk_sscore.appendChild(issuerP_PK_alg);	
	}


	document.body.appendChild(algo_pk_p);
	document.body.appendChild(algo_pk_text);
	document.body.appendChild(algo_pk_sscore);
	document.body.appendChild(document.createElement("BR"));	
	document.body.appendChild(document.createElement("BR"));
	
	return;
}
function print_fingerprints(message){

	let fingerPrintSHA1 = document.createElement("p");
	fingerPrintSHA1.style.fontSize = "small";
	
	//SHA1
	document.body.appendChild(document.createElement("p").appendChild(bold_size_text_TextNodeLarge("SHA1:")));		
	fingerPrintSHA1.appendChild(document.createTextNode(message.certificates[i].fingerprint.sha1));
	document.body.appendChild(fingerPrintSHA1);
	
	//SHA256		
	let fingerPrintSHA256 = document.createElement("p");
	fingerPrintSHA256.style.fontSize = "small";
	document.body.appendChild(document.createElement("p").appendChild(bold_size_text_TextNodeLarge("SHA256:")));
	fingerPrintSHA256.appendChild(document.createTextNode(message.certificates[i].fingerprint.sha256));
	document.body.appendChild(fingerPrintSHA256);

}
function print_critical_extensions(dadesCertificat){

	if(dadesCertificat.criticalExtensions.length >0 && dadesCertificat.criticalExtensions !== undefined){
				
		let ext_crt_p = bold_size_text_TextNodeLarge("Critical extensions:");
		document.body.appendChild(document.createElement("p").appendChild(ext_crt_p));
		document.body.appendChild(document.createElement("BR"));
		document.body.appendChild(document.createElement("BR"));

		for (let critical in dadesCertificat.criticalExtensions){
										
			let ext_crt_p = document.createElement('span');
			ext_crt_p.style.marginLeft="15px";
			ext_crt_p.appendChild(document.createTextNode(strings.names[dadesCertificat.criticalExtensions[critical]].name.long));
			document.body.appendChild(document.createElement("p").appendChild(ext_crt_p));
			document.body.appendChild(document.createElement("BR"));
		
		}
		document.body.appendChild(document.createElement("BR"));		
	
	}

}

function print_estrelles(){
	//Estrelles amb la puntuació
	if((Math.round(puntuacioTOTAL) > puntuacioTOTAL) && (((Math.round(puntuacioTOTAL) - puntuacioTOTAL) >= 0.35) && ((Math.round(puntuacioTOTAL) - puntuacioTOTAL) <= 0.50))){
		
		for (i = 0; i < Math.round(puntuacioTOTAL) -1 ; i++) { 
			let img = document.createElement("img");
			img.style.cssText = 'padding:5px;';
			img.src = "../images/full19.png";
			img.width = 33;
			img.height = 33;
			img.style.verticalAlign="middle";
			img.setAttribute("verticalAlign","middle");
			estrelles.appendChild(img);
		}
		
		//Afegim la meitat estrella
		
		let img = document.createElement("img");
		img.style.cssText = 'padding:5px;';
		img.src = "../images/half19.png";
		img.width = 33;
		img.height = 33;
		img.style.verticalAlign="middle";
		img.setAttribute("verticalAlign","middle");
		estrelles.appendChild(img);
		i++;
		
		for (;i<10;i++){
			let img = document.createElement("img");
			img.style.cssText = 'padding:5px;';
			img.src = "../images/empty19.png";
			img.width = 33;
			img.height = 33;
			img.style.verticalAlign="middle";
			img.setAttribute("verticalAlign","middle");
			estrelles.appendChild(img);
		}
	
	}
	else {
		
		for (i = 0; i < Math.round(puntuacioTOTAL); i++) { 
			let img = document.createElement("img");
			img.style.cssText = 'padding:5px;';
			img.src = "../images/full19.png";
			img.width = 33;
			img.height = 33;
			img.style.verticalAlign="middle";
			img.setAttribute("verticalAlign","middle");
			estrelles.appendChild(img);
		}
		
		if(Math.round(puntuacioTOTAL) - puntuacioTOTAL <= -0.40 && Math.round(puntuacioTOTAL) - puntuacioTOTAL >= -0.50){
			let img = document.createElement("img");
			img.style.cssText = 'padding:5px;';
			img.src = "../images/half19.png";
			img.width = 33;
			img.height = 33;
			img.style.verticalAlign="middle";
			img.setAttribute("verticalAlign","middle");
			estrelles.appendChild(img);
			i++;
		}

		
		for (;i<10;i++){
			let img = document.createElement("img");
			img.style.cssText = 'padding:5px;';
			img.src = "../images/empty19.png";
			img.width = 33;
			img.height = 33;
			img.style.verticalAlign="middle";
			img.setAttribute("verticalAlign","middle");
			estrelles.appendChild(img);
		}
	
	}	
}

function print_header_cert(name,color){

			let certWebText = document.createElement("p");
			certWebText.style.color=color;
			certWebText.style.textAlign = "center";
			certWebText.style.fontSize = "x-large";
			certWebText.appendChild(document.createTextNode(name));
			document.body.appendChild(certWebText);
			
}

function get_weights_score(){

	chrome.storage.local.get(null, (res) => {

	  //Pes de la connexió
	  if (res.connection) {
		pes_connexio = res.connection;
	  }
	  
	  //Pes de la cadena de certificats
	  if (res.cert_chain) {
		pes_cadena_certificats = res.cert_chain;
	  }

	  //Pes certificat WEB
	  if (res.cert_web) {
		pes_certWEB = res.cert_web;
	  }

	  //Pes certificats CA
	  if (res.cert_CAs) {
		pes_certCA = res.cert_CAs;
	  }

	  //Pes certificat root
	  if (res.cert_root) {
		pes_certROOT = res.cert_root;
	  }
	  
	  //Pes del CipherSuite en el total
	  if (res.cps) {
		pes_CPS = res.cps;
	  }
	  //Pes Perfect Forward Secrecy
	  if (res.pfs) {
		pes_PFS = res.pfs;
	  }
	  //Pes estat certificat
	  if (res.certStatus) {
		pes_certStatus = res.certStatus;
	  }
	  //Pes Extension Validesa certificat
	  if (res.ev) {
		pes_EV = res.ev;
	  };
	  //Pes Signatura
	  if (res.sig) {
		pes_SIG = res.sig;
	  };
	  //Pes Algoritme Clau Pública
	  if (res.pk) {
		pes_PK = res.pk;
	  }
	  /*-- Pesos del Cipher Suite --*/
	  
	  // Pes protocol SSL/TLS
	  if (res.tls) {
		pes_TLS = res.tls;
	  }
	  //Pes algoritme intercanvi claus
	  if (res.ke) {
		pes_KE = res.ke;
	  }
	  //Pes algoritme autenticació
	  if (res.sigauth) {
		pes_SIGAUTH = res.sigauth;
	  }
	  //Pes algoritme xifrat simètric
	  if (res.bc) {
		pes_BC = res.bc;
	  }
	  //Pes algoritme càlcul hash
	  if (res.hash) {
		pes_Hash = res.hash;
	  }

	});

}
function change_icon_color(color){

	if(color=="green"){
		browser.browserAction.setIcon({path: "../icons/TLSiconGreen38.png"});
	}
	else if(color=="yellow"){
		browser.browserAction.setIcon({path: "../icons/TLSiconYellow38.png"});
	}
	else if(color=="red"){
		browser.browserAction.setIcon({path: "../icons/TLSiconRed38.png"});
	}

}

function value_protocol_SSL(message){
	
	if(message.protocolVersion != null && message.protocolVersion !== undefined && message.protocolVersion !== "") {

		if(message.protocolVersion === "TLSv1.3"){
			puntuacioProto_TLS = 10.0;
		}

		else if(message.protocolVersion === "TLSv1.2"){
			puntuacioProto_TLS = 10.0;
		}

		else if(message.protocolVersion === "TLSv1.1"){
			puntuacioProto_TLS = 6.0;
		}

		else if(message.protocolVersion === "TLSv1"){
			puntuacioProto_TLS = 0.0;
		}

		else if(message.protocolVersion === "SSLv0.3"){
			puntuacioProto_TLS = 0.0;
		}
		
		else if(message.protocolVersion === "SSLv0.2"){
			puntuacioProto_TLS = 0.0;
		}
		
		else if(message.protocolVersion === "unknown" || message.protocolVersion !== undefined){
			puntuacioProto_TLS = 0.0; //Not valid
		}
	}
	else {
		
		document.getElementById("tot").innerHTML="The connection is not secure or the protocol is unknown.";
		//Debugging
		console.log("Error in obtaining protocol version.")

	};
}
function value_cipher_suite(message){

	if(message.cipherSuite !== undefined){
		//Format Cipher suite del TLSv1.3 és diferent, ja no es passa informació del KE o Firefox no l'exposa
		if(message.protocolVersion === 'TLSv1.3'){
	
			//Dividim el string del ciphersuite
			let res = message.cipherSuite.lastIndexOf("_");
			//Obtenim el Bulk Cipher
			BC = message.cipherSuite.substring(0,res);
			BC = BC.split("TLS_")[1];
			
			//Obtenim el MACHash
			hash = message.cipherSuite.substring(message.cipherSuite.lastIndexOf("_")+1,message.cipherSuite.length);	
			
			var BC_txt = document.getElementById("BC_txt");
			//.innerHTML=BC.split("TLS_")[1].replace(/_/g,' ');
			
			document.getElementById("MHASH_txt").innerHTML=hash;

			var img_ke = document.getElementById("keyExchange_img");
			img_ke.setAttribute("width", "25");
			img_ke.setAttribute("height", "25");
			img_ke.setAttribute("alt", "OK");
			
			//Obtenim el KE
			//TLSv.1.3. Usa ECDHE o DHE, propietat forward secrecy (algorítmes efímers)
			
			if (message.keaGroupName!==undefined && message.keaGroupName!=='custom'){
			
				puntuacioKE = 9.0; //default
				pfs=10.0; //TLSv1.3 només efímers
				document.getElementById("keyExchange_txt").innerHTML="Elliptic curve Diffie-Hellman";
				img_ke.setAttribute("src", "../images/OK.png");
				
				if(message.keaGroupName.toUpperCase()==='X25519'){
					puntuacioKE = 9.0;
					document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 256-bit ";

				}
				else if (message.keaGroupName.toUpperCase()==='X448'){
					puntuacioKE = 10.0;
					document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 448-bit ";
				}
				else if (message.keaGroupName.toUpperCase().includes("P192")){
					puntuacioKE = 4.0;
					document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 192-bit ";
					img_ke.setAttribute("src", "../images/KO.png");
				}	
				else if (message.keaGroupName.toUpperCase().includes("P224")){
					puntuacioKE = 5.0;
					document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 224-bit ";
				}			
				else if (message.keaGroupName.toUpperCase().includes("P256")){
					puntuacioKE = 9.0;
					document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 256-bit ";
				}
				else if (message.keaGroupName.toUpperCase().includes("P384")){
					puntuacioKE = 10.0;
					document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 384-bit ";
				}
				else if (message.keaGroupName.toUpperCase().includes("P521")){
					puntuacioKE = 10.0;
					document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 521-bit ";
				}
				

			}
			else{
				puntuacioKE = 9.0;
				//No s'ha identificat l'algoritme possiblement per error de la API però TLSv1.3 només accepta protocols efímers i molt segurs ECDHE i DHE, doncs agafem el més baix possible que és 9.75 (DHE2048)
				document.getElementById("keyExchange_txt").innerHTML="Diffie-Hellman Ephemeral (estimation)";
				img_ke.setAttribute("src", "../images/OK.png");
				document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML="key size not provided";
			
			}
	
		}
		else{ 
			//Per la resta de protocols SSL/TLS (NO v1.3)
			//Dividim el string del ciphersuite
			let res = message.cipherSuite.split("_WITH_");
			//Primera part Cipher Suite
			let res1 = res[0].split("_"); //Intercanvi de clau i firma. Posició 1 i 2 del array
			KE = res1[1];
			
			if (res1.length===3){
				if(res1[2] ==='EXPORT'){
					sign = res1[1];
					KE = res1[1]+"_"+res1[2];
				}
			}
			
			else if (KE === 'RSA') sign = "RSA";
			//Segona part Cipher Suite
			BC = res[1].substring(0,res[1].lastIndexOf("_")); //Bulk cipher
			hash = res[1].substring(res[1].length,res[1].lastIndexOf("_")+1); //MAC hash

			
			if(KE==='ECDHE'){
				document.getElementById("keyExchange_txt").innerHTML='Elliptic curve Diffie-Hellman Ephemeral';
			
			}
			else if(KE==='DHE'){
				document.getElementById("keyExchange_txt").innerHTML='Diffie-Hellman Ephemeral';
			
			}
			else if(KE==='DH'){
				document.getElementById("keyExchange_txt").innerHTML='Diffie-Hellman';
			
			}
			else if(KE==='ECDH'){
				document.getElementById("keyExchange_txt").innerHTML='Elliptic curve Diffie-Hellman';
			
			}
			else if(KE==='RSA'){
				document.getElementById("keyExchange_txt").innerHTML='RSA (Rivest–Shamir–Adleman)';			
			}
			else if(KE==='RSA_EXPORT'){
				document.getElementById("keyExchange_txt").innerHTML='RSA (Rivest–Shamir–Adleman) EXPORT ';			
			}			
			
			
			let img_ke = document.getElementById("keyExchange_img");
			img_ke.setAttribute("width", "25");
			img_ke.setAttribute("height", "25");
			img_ke.setAttribute("alt", "OK");
			
			var BC_txt = document.getElementById("BC_txt");

			//document.getElementById("BC_txt").innerHTML=BC_string;
			document.getElementById("MHASH_txt").innerHTML=hash;
			
			//Valor intercanvi de claus entre client i servidor per als protocols SSL/TLS fins verisó TLSv1.2
		
			if(KE === "ECDHE"){
				puntuacioKE = 9.0; //default
				pfs=10.0;
				img_ke.setAttribute("src", "../images/OK.png");

				
				if(message.keaGroupName!== undefined && message.keaGroupName!== 'custom'){
					
					if(message.keaGroupName.toUpperCase()==='X25519'){
						puntuacioKE = 9.0;
						document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 256-bit ";

					}
					else if (message.keaGroupName.toUpperCase()==='X448'){
						puntuacioKE = 10.0;
						document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 448-bit ";
					}
					else if (message.keaGroupName.toUpperCase().includes("P192")){
						puntuacioKE = 4.0;
						document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 192-bit ";
						img_ke.setAttribute("src", "../images/KO.png");

					}	
					else if (message.keaGroupName.toUpperCase().includes("P224")){
						puntuacioKE = 5.0;
						document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 224-bit ";
					}				
					else if (message.keaGroupName.toUpperCase().includes("P256")){
						puntuacioKE = 9.0;
						document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 256-bit ";
					}
					else if (message.keaGroupName.toUpperCase().includes("P384")){
						puntuacioKE = 10.0;
						document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 384-bit ";
					}
					else if (message.keaGroupName.toUpperCase().includes("P521")){
						puntuacioKE = 10.0;
						document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 521-bit ";
					}

				}
				else{
					document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML="key size not provided";
				}
				

			}
			else if(KE === "DHE"){
				
				puntuacioKE = 8.0;
				pfs=10.0;
				
				img_ke.setAttribute("src", "../images/OK.png");

			}
			else if(KE === "ECDH"){
				
				puntuacioKE = 9.0; //default
				img_ke.setAttribute("src", "../images/OK.png");

				
				if(message.keaGroupName!== undefined && message.keaGroupName!== 'custom'){
					
					if(message.keaGroupName.toUpperCase()==='X25519'){
						puntuacioKE = 9.0;
						document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 256-bit ";

					}
					else if (message.keaGroupName.toUpperCase()==='X448'){
						puntuacioKE = 10.0;
						document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 448-bit ";
					}
					else if (message.keaGroupName.toUpperCase().includes("P192")){
						puntuacioKE = 4.0;
						document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 192-bit ";
						img_ke.setAttribute("src", "../images/KO.png");

					}	
					else if (message.keaGroupName.toUpperCase().includes("P224")){
						puntuacioKE = 5.0;
						document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 224-bit ";
					}					
					else if (message.keaGroupName.toUpperCase().includes("P256")){
						puntuacioKE = 9.0;
						document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 256-bit ";
					}
					else if (message.keaGroupName.toUpperCase().includes("P384")){
						puntuacioKE = 10.0;
						document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 384-bit ";
					}
					else if (message.keaGroupName.toUpperCase().includes("P521")){
						puntuacioKE = 10.0;
						document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML=" 521-bit ";
					}

				}
				else{
					document.getElementById("keyExchangeBitsKeyLenght_txt").innerHTML="";
				}

			}

			else if(KE === "DH"){
				puntuacioKE = 7.0;			
				img_ke.setAttribute("src", "../images/KO.png");
			}

			else if(KE === "RSA"){
				puntuacioKE = 6.0; 			
				img_ke.setAttribute("src", "../images/KO.png");

			}
			else if(KE === "RSA_EXPORT"){
				puntuacioKE = 2.0; 			
				img_ke.setAttribute("src", "../images/KO.png");

			}
		}
		//Valor puntuació Bulk Cipher (algoritme encriptació missatges, clau simetrica) i MAC hash (s'aplica a tots els protocols SSL/TLS)
	
		if(BC === "AES_256_CBC"){
			puntuacioBC = 8; 
			BC_txt.innerHTML="AES key size 256-bit and mode CBC";
		}
		
		else if(BC === "AES_128_CBC"){
			puntuacioBC = 7; 
			BC_txt.innerHTML="AES key size 128-bit and mode CBC";
		}

		else if(BC === "AES_256_GCM"){
			puntuacioBC = 10;
			AEAD = true;	
			BC_txt.innerHTML="AES key size 256-bit and mode GCM";			
		}
		
		else if(BC === "AES_128_GCM"){
			puntuacioBC = 9;
			AEAD = true;
			BC_txt.innerHTML="AES key size 128-bit and mode GCM";
		}		
		else if(BC === "AES_128_CCM"){
			puntuacioBC = 9;
			AEAD = true;
			BC_txt.innerHTML="AES key size 128-bit and mode CCM";
		}	
		else if(BC === "AES_256_CCM"){
			puntuacioBC = 10;
			AEAD = true;
			BC_txt.innerHTML="AES key size 256-bit and mode CCM";
		}				
		else if(BC === "CHACHA20_POLY1305"){
			puntuacioBC = 10; 
			AEAD = true;
			BC_txt.innerHTML="CHACHA20-POLY1305 key size 256-bit";
		}			
		
		else if(BC === "CAMELLIA_256_CBC"){
			puntuacioBC = 8; 
			BC_txt.innerHTML="CAMELLIA key size 256-bit and mode CBC";
		}
		
		else if(BC === "CAMELLIA_128_CBC"){
			puntuacioBC = 7; 
			BC_txt.innerHTML="CAMELLIA key size 128-bit and mode CBC";
		}
		
		else if(BC === "SEED_CBC"){
			puntuacioBC = 1; 
			BC_txt.innerHTML="SEED key size 128-bit and mode CBC";
		}
		
		else if(BC === "3DES_EDE_CBC"){
			puntuacioBC = 1; 
			BC_txt.innerHTML="3DES-EDE key size 168-bit and mode CBC";
		}
		
		else if(BC === "RC4_128"){
			puntuacioBC = 1; 
			BC_txt.innerHTML="RC4 key size 128-bit";
		}
		
		else if(BC === "DES_CBC"){
			puntuacioBC = 1; 
			BC_txt.innerHTML="DES key size 64-bit and mode CBC";
		}
		
		else if(BC === "DES40_CBC"){
			puntuacioBC = 1; 
			BC_txt.innerHTML="DES key size 40-bit and mode CBC";
		}
		
		else if(BC === "RC2_CBC_40"){
			puntuacioBC = 1; 
			BC_txt.innerHTML="RC2 key size 40-bit and mode CBC";
		}	
		
		else if(BC === "RC4_40"){
			puntuacioBC = 1; 
			BC_txt.innerHTML="RC4 key size 40-bit";
		}
		
		else if(BC === "RC4"){
			puntuacioBC = 1; 
			BC_txt.innerHTML="RC4 key size 40-bit";
		}
		
		else if(BC === "DES"){
			puntuacioBC = 1; 
			BC_txt.innerHTML="DES";
		}

		//Valor puntuació MAC hash

		if(hash === "SHA512"){
			puntuacioHash = 10; 
		}

		else if(hash === "SHA384"){
			puntuacioHash = 10; 
		}
		
		else if(hash === "SHA256"){
			puntuacioHash = 9; 
		}
		
		else if(hash === "SHA224"){
			puntuacioHash = 5; 
		}
		
		else if(hash === "SHA" || hash === "SHA1" || hash === "SHA-1"){
			puntuacioHash = 3; 
		}
		
		else if(hash === "MD5"){
			puntuacioHash = 1; 
		}
		
		else if(hash === "MD2"){
			puntuacioHash = 0; 
		}
				
		//Agreguem la informació que usa AEAD en cas afirmatiu
		if(AEAD){
			
			let AEAD_img = document.getElementById("AEAD_img");
			let AEAD_txt = document.getElementById("AEAD_txt")
			AEAD_txt.style.verticalAlign="middle";
			AEAD_txt.appendChild(document.createTextNode("  (AEAD)  "));
			AEAD_img.setAttribute("src", "../images/OK.png");
			AEAD_img.setAttribute("width", "25");
			AEAD_img.setAttribute("height", "25");
			AEAD_img.setAttribute("alt", "OK");
			AEAD_img.innerHTML=AEAD_img;

		}
		
		//Signature (Autenticació)
		
		var signatureSchemeName = undefined;
		
		signatureSchemeName= message.signatureSchemeName;
		
		var signatureSchemeName_img = document.getElementById("signatureSchemeName_img");			
		signatureSchemeName_img.setAttribute("width", "25");
		signatureSchemeName_img.setAttribute("height", "25");
		signatureSchemeName_img.setAttribute("alt", "OK");
		
		puntuacioAUTH = 7.0; //Possible desconegut, per defecte si no es cumpleix cap altre
		signatureSchemeName_img.setAttribute("src", "../images/OK.png");
		
		if(signatureSchemeName!== undefined && signatureSchemeName!== 'custom'){
		
			if(signatureSchemeName === 'ECDSA-P192-SHA160') {
				puntuacioAUTH = 4.0;
				signatureSchemeName_img.setAttribute("src", "../images/KO.png");
			}
			else if(signatureSchemeName === 'ECDSA-P224-SHA224') {
				puntuacioAUTH = 5.0;
				signatureSchemeName_img.setAttribute("src", "../images/OK.png");
			}
			else if(signatureSchemeName === 'ECDSA-P256-SHA256') {
				puntuacioAUTH = 9.0;
				signatureSchemeName_img.setAttribute("src", "../images/OK.png");
			}
			else if(signatureSchemeName === 'ECDSA-P384-SHA384') {
				puntuacioAUTH = 10.0;
				signatureSchemeName_img.setAttribute("src", "../images/OK.png");

			}
			
			else if(signatureSchemeName === 'ECDSA-P521-SHA512'){
				puntuacioAUTH = 10.0;
				signatureSchemeName_img.setAttribute("src", "../images/OK.png");

			}
			else if(signatureSchemeName === 'RSA-PSS-SHA1' || signatureSchemeName === 'RSA-PSS-SHA' || signatureSchemeName === 'RSA-PSS-SHAMD5' || signatureSchemeName === 'RSA-PSS-SHA1MD5'){
				puntuacioAUTH = 2.0;
				signatureSchemeName_img.setAttribute("src", "../images/KO.png");
			}
			else if(signatureSchemeName === 'RSA-PSS-SHA224'){
				puntuacioAUTH = 5.0;
				signatureSchemeName_img.setAttribute("src", "../images/OK.png");
			}
			else if(signatureSchemeName === 'RSA-PSS-SHA256'){
				puntuacioAUTH = 9.0;
				signatureSchemeName_img.setAttribute("src", "../images/OK.png");
			}
			else if(signatureSchemeName === 'RSA-PSS-SHA384'){
				puntuacioAUTH = 10.0;
				signatureSchemeName_img.setAttribute("src", "../images/OK.png");
			}
			else if(signatureSchemeName === 'RSA-PSS-SHA512'){
				puntuacioAUTH = 10.0;
				signatureSchemeName_img.setAttribute("src", "../images/OK.png");
			} 
			else if(signatureSchemeName === 'RSA-PKCS1-SHA1' || signatureSchemeName === 'RSA-PKCS1-SHA' || signatureSchemeName === 'RSA-PKCS1-SHAMD5' || signatureSchemeName === 'RSA-PKCS1-SHA1MD5'){
				puntuacioAUTH = 2.0;
				signatureSchemeName_img.setAttribute("src", "../images/KO.png");
			}
			else if(signatureSchemeName.includes('RSA-PKCS1') && signatureSchemeName.includes('RIPEMD128')){
				puntuacioAUTH = 2.0;
				signatureSchemeName_img.setAttribute("src", "../images/KO.png");
			}	
			else if(signatureSchemeName.includes('RSA-PKCS1') && signatureSchemeName.includes('RIPEMD160')){
				puntuacioAUTH = 3.0;
				signatureSchemeName_img.setAttribute("src", "../images/KO.png");
			}			
			else if(signatureSchemeName === 'RSA-PKCS1-SHA224'){
				puntuacioAUTH = 5.0;
				signatureSchemeName_img.setAttribute("src", "../images/OK.png");
			}
			else if(signatureSchemeName === 'RSA-PKCS1-SHA256'){
				puntuacioAUTH = 9.0;
				signatureSchemeName_img.setAttribute("src", "../images/OK.png");
			}
			else if(signatureSchemeName === 'RSA-PKCS1-SHA384'){
				puntuacioAUTH = 10.0;
				signatureSchemeName_img.setAttribute("src", "../images/OK.png");
			}
			else if(signatureSchemeName === 'RSA-PKCS1-SHA512'){
				puntuacioAUTH = 10.0;	
				signatureSchemeName_img.setAttribute("src", "../images/OK.png");
			}	
			else if(signatureSchemeName === undefined && sign ==='DSS' ){			
				puntuacioAUTH = 4.0; //O mirar el KE i determinar 
				signatureSchemeName_img.setAttribute("src", "../images/KO.png");
			}
			else if(signatureSchemeName === 'custom' && sign ==='DSS'){
				puntuacioAUTH = 4.0; //Probablement usi un subgrup baix en seguretat (Estimació)
				signatureSchemeName_img.setAttribute("src", "../images/KO.png");
			}
			else if(signatureSchemeName === 'custom'){
				puntuacioAUTH = 7.0; //Probablement usi un subgrup baix en seguretat (Estimació)
				signatureSchemeName_img.setAttribute("src", "../images/OK.png");
			}
			else if(signatureSchemeName === undefined){
				puntuacioAUTH = 7.0; //Probablement usi un subgrup baix en seguretat (Estimació)
				signatureSchemeName_img.setAttribute("src", "../images/OK.png");
			}
		
		
		}

		else if (signatureSchemeName === undefined || signatureSchemeName === 'custom'){
			
			if(sign.toUpperCase() ==='ANON'){
				puntuacioAUTH = 0.0;
				signatureSchemeName_img.setAttribute("src", "../images/KO.png"); 
			}
		}

	}
}

function print_total_score(puntuacioTOTAL){

	let x = document.getElementById("sscore");
	let x2 = document.getElementById("maxGlobPunt");
	
	if (puntuacioTOTAL<5) {
	
		x.style.color = "red";
		change_icon_color("red");
	}
	else if (puntuacioTOTAL>5 && puntuacioTOTAL<7){
		x.style.color = "yellow";
		change_icon_color("yellow");
	}
	else if (puntuacioTOTAL>7 && puntuacioTOTAL<8){
		x.style.color = "blue";
		change_icon_color("green");
	}
	else if (puntuacioTOTAL>=8) {
		x.style.color = "green";
		change_icon_color("green");
	}
	x.style.fontSize = "xx-large";
	x.innerHTML= ((Math.round(puntuacioTOTAL*100)) /100);
	
	x2.style.fontSize = "xx-large";
	x2.innerHTML= "/10";

}

async function store_local_values(dades) {
 
	var dades_json_to_file = {URL: URL_short, dades: dades}; 

	if (navigator.storage && navigator.storage.persist())
		
		if(navigator.storage.persist()){
			
				const storedData = await IDBFiles.getFileStorage();
				let blob = new Blob([JSON.stringify(dades_json_to_file, null, 2)], {type : 'application/json'});
				await storedData.put("resultat.dat",blob); 
				
				
				let file = new File([JSON.stringify(dades_json_to_file, null, 2)], "resultats.json", {type : 'application/json'});
				await storedData.put("resultat.json",file);
			
		}
		else
			browser.storage.local.set(dades_json_to_file);
}

function print_pfs(){

	if(pfs==10){
		
		let greenCheck = document.getElementById("PFS_txt");
		greenCheck.setAttribute("src", "../images/OK.png");
		greenCheck.setAttribute("width", "25");
		greenCheck.setAttribute("height", "25");
		greenCheck.setAttribute("alt", "OK");
		greenCheck.setAttribute("verticalAlign", "middle");

	}
	else{

		let greenCheck = document.getElementById("PFS_txt");
		greenCheck.setAttribute("src", "../images/KO.png");
		greenCheck.setAttribute("width", "25");
		greenCheck.setAttribute("height", "25");
		greenCheck.setAttribute("alt", "KO");
		greenCheck.setAttribute("verticalAlign", "middle");

	}
}